--------------------------------------------------
-- Nortel Alarm to Trap decoder
-- (c) UK 2008 Scannex Electronics Ltd
-- www.scannex.co.uk
-- 2008-06-24
--------------------------------------------------

-- Table of Nortel Alarms
na_list={}

-- Nortel Alarm Add
function na_add(txt,trap,desc)
 local atxt=string.match(txt,"(%u+)")
 local astart=string.match(txt,"(%d+)")
 local aend=string.match(txt,"-(%d+)")
 local e=na_list[atxt]
 if not e then na_list[atxt]={}; e=na_list[atxt]; e.r={}; end
 local v={}
 v.min=astart
 v.max=aend
 v.desc=desc
 v.trap=trap
 table.insert(e.r,v)
end

-- Nortel Alarm Find
function na_find(txt)
 local atxt=string.match(txt,"(%u+)")
 local an=string.match(txt,"(%d+)")
 local e=na_list[atxt]
 if not e or not e.r then return NULL end
 local i,v
 for i,v in ipairs(e.r)
 do
  if v and 
     ( (not v.max and (v.min==an)) or 
       (v.max and (an>=v.min) and (an<=v.max)))
  then
   return v.trap, v.desc, atxt..an
  end
 end
 return NULL
end

-- Populate the code-to-trap list
na_add("ACD001",        1 , "Noisy ACD terminal disabled.")
na_add("AMH001-004",    10, "Message handler fault.")
na_add("BSD080-089",    10, "CPU and CMA switchover faults")
na_add("BSD090",        10, "Power Fault Detected.")
na_add("BSD100-139",    10, "Inter Group Switch failure.")
na_add("BSD200-299",    10, "Continuity test failure.")
na_add("BSD600-663",    1 , "Loop and Signalling test fail")
na_add("CED010-011",    1 , "Common equipment diagnostic")
na_add("CED012-013",    10, "Memory test failure")
na_add("CED014",        10, "Faulty MISC on active CPU")
na_add("CED015-017",    1 , "Common equipment diagnostic")
na_add("CED060-075",    10, "CE bus,CPU,CMA faults")
na_add("CED080-081",    1 , "Memory card failures")
na_add("CED082",        10, "CPU midnight changeover fault")
na_add("CED083-CED099", 1 , "CE enable/disable tests")
na_add("CED100-117",    10, "MTR and Memory card failure")
na_add("CNF021-023",    10, "Conference pack faults")
na_add("CRI000-999",    1 , "")
na_add("CSA001-002",    10, "Command and Status link faults")
na_add("DCH1001-1002",  1 , "Primitive i.d problems")
na_add("DCH1003-1005",  10, "PRI protocal/hardware errors")
na_add("DCH1006-1008",  1 , "PRI establish errors")
na_add("DCH1009-1010",  10, "DCHI OOS/disabled")
na_add("DCH1011-1043",  1 , "DCHI establish failures")
na_add("DCH300-305",    1 , "DCHI test failures")
na_add("DCH421",        1 , "DCHI overload control")
na_add("DCH4283",       1 , "D-Channel release event")
na_add("DTA005-006",    10, "Remote alarm occurence")
na_add("DTA007",        1 , "PRI yellow alarm cleared")
na_add("DTA008",        10, "PRI yellow alarm disabled")
na_add("DTA009",        10, "Phase lock loop alarm")
na_add("DTA030",        10, "Alarm status input message")
na_add("DTA108",        1 , "PRI2 loop in G1 NNC state")
na_add("DTA109",        10, "PRI2 loop in G1 OOS state")
na_add("DTA110",        1 , "PRI2 Loop in G2 MNT state")
na_add("DTA111",        1 , "PRI2 Loop in G2 NNC state")
na_add("DTA112",        1 , "PRI2 loop in G2 OOS state")
na_add("DTA200-211",    1 , "Alarm detected on DTI card x")
na_add("DTA212",        10, "DTI loop in group 1 OOS state")
na_add("DTA213-214",    1 , "DTI loop in MNT and NNC stat")
na_add("DTA215",        10, "DTI loop in group 2 OOS state")
na_add("DTA216-221",    1 , "DTI loop state errors")
na_add("DTA222-223",    10, "Auto start and ABCD bit errors")
na_add("DTA223-226",    1 , "DTI signal and service errors")
na_add("DTA300-312",    1 , "PRI2 slip and loop errors")
na_add("DTA320",        10, "DTI loop error reporting")
na_add("DTA321-323",    1 , "DTI error reporting")
na_add("DTA324-325",    5 , "DTI2 Phantom loop errors")
na_add("DTC006",        10, "Clock switched to Free run")
na_add("DTI030-031",    10, "DTI locaL/remote alarms")
na_add("DTI032-035",    1 , "DTI card/clock/loop diagnostic")
na_add("DTI036",        10, "Network loop/card faulty")
na_add("DTI037-038",    1 , "DTI alarm/channel diagnostics")
na_add("DTM300-347",    1 , "Digital trunk maintenance")
na_add("EDD018-049",    10, "Equipment Data Dump errors")
na_add("EDD101",        10, "Dynamic memory request failure")
na_add("ELAN0000",      10, "ELAN Server disabled.")
na_add("ELAN0001",      10, "ELAN Server fail to open skt")
na_add("ELAN0002",      10, "ELAN Server can't bind skt")
na_add("ELAN0009",      10, "Elan x host or nwk problems")
na_add("ELAN0014",      1 , "ELAN x host enabled")
na_add("ELAN0023",      10, "TCP socket errors")
na_add("ELAN0024",      10, "TCP write fatal error")
na_add("ELAN0025",      10, "TCP error write fail multiple")
na_add("ELAN0026",      10, "TCP error: multiple msg failur")
na_add("ELAN0027",      1 , "Sig server messages")
na_add("ELAN0028",      10, "Service failed to register pbx")
na_add("ELAN0029",      1 , "Service has registered withcs")
na_add("ERR3001",       10, "APL link transmission problems")
na_add("ERR4021",       1 , "Meridian Mail MP alarm")
na_add("ESDA001",       10, "ESDI Link OOS")
na_add("ESDI002",       1 , "ESDI loop-back message failure")
na_add("FIR000-999",    1 , "Fibre remote alarm")
na_add("INI000",        10, "Initialisation has taken place")
na_add("MISP300-308",   10, "MISP card problems")
na_add("NPR334",        1 , "Peripheral software download")
na_add("NWS008",        10, "Serious data error detected")
na_add("NWS030-031",    10, "Clock switching function error")
na_add("NWS042",        10, "Net interface card has failed.")
na_add("NWS101-103",    10, "Loop/Per Sig card failure")
na_add("NWS141",        10, "IGS card failed to respond")
na_add("NWS204",        10, "Network loop command failure")
na_add("NWS211",        10, "Shelf signalling test failure")
na_add("NWS301",        10, "PE card failure")
na_add("NWS501",        1 , "Telset signalling test failure")
na_add("NWS609",        10, "XNET/XPND card problems")
na_add("OVD001-010",    10, "System overload problems")
na_add("OVD021-033",    10, "Invalid input errors")
na_add("OVL305",        10, "System monitor message errors")
na_add("PWR0001-002",   10, "Partial/complete power failure")
na_add("PWR0006",       10, "Sensor alarm has tripped.")
na_add("PWR004-007",    10, "System overheat problems")
na_add("SDL0000",       1 , "Peripheral software download")
na_add("SDL100",        1 , "Software download status")
na_add("SDL1301-1302",  1 , "Failure starting PSW.")
na_add("SDL2401",       1 , "Call register failure")
na_add("SDL7111",       1 , "Failure writing data to loop.")
na_add("SYS0000",       10, "System reload has taken place.")
na_add("SYS0100",       10, "Sysload invokes CPU switchover")
na_add("SYS0202-0209",  10, "Corrupt data structure.")
na_add("SYS0400-0430",  10, "Config data conflict.")
na_add("SYS0500-0520",  10, "CPU,CMA test failures")
na_add("SYS0600-0674",  10, "Corrupt data structure")
na_add("SYS0800-0910",  10, "Data allocation failures")
na_add("SYS0999",       10, "FATAL-protected memory")
na_add("XCT100",        10, "Conference TDS/MFS card fail.")
na_add("XMI000",        10, "Network card (NT8D04) failure.")
na_add("XMI101-103",    10, "Card polling/TN failure")


function na_onrecord(rec, chnl, tag)
 mem.write(chnl, rec)
 local tn,de,al = na_find(rec)
 if tn
 then
	snmp.trap(1000+tn, string.format("%s:%s", al, de))
 end
end

x.chnl[4].src.onrecord = na_onrecord
